package com.jakubu9333.grammarManager.config;

import com.jakubu9333.grammarManager.dao.XmlDataDao;
import org.basex.BaseXServer;
import org.basex.api.client.ClientSession;
import org.basex.core.cmd.Check;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;
import org.springframework.http.HttpStatus;
import org.springframework.web.server.ResponseStatusException;

import java.io.IOException;

/**
 * @author Jakub Uhlarik
 */
@Configuration
public class XmlDataConfig {
    private XmlDataDao xmlDataDao;
    public static final String DB_NAME="grammarsDB";
    @Autowired
    private Environment environment;

    @Bean
    public XmlDataDao baseXMlDao() {
        ClientSession session;


        try {
            String host = environment.getProperty("DATABASE_HOST");
            String password= environment.getProperty("DATABASE_PASSWORD");
            if (password==null){
                password="admin";
            }
            if (host == null) {
                host = "localhost";
                new BaseXServer ("-P"+password);
            }
            session = new ClientSession(host, 1984, "admin", password);
            System.out.println("\n\nConnecting to database at: "+host+"\n");
            session.execute(new Check(DB_NAME));


        } catch (IOException e) {
            throw new ResponseStatusException(HttpStatus.INTERNAL_SERVER_ERROR, e.getMessage(), e);
        }

        this.xmlDataDao = new XmlDataDao(session);

        return this.xmlDataDao;
    }

}
